# Copyright 2020 Gentoo Authors
# Distributed under the terms of the GNU General Public License v2

EAPI=7

PYTHON_COMPAT=( python3_{6,7,8} )

inherit distutils-r1

DESCRIPTION="Tool for automatic upgrades"
HOMEPAGE="https://fulh.ax/feffe/sau"
SRC_URI="https://fulh.ax/feffe/sau/-/archive/v${PV}/sau-v${PV}.tar.gz"

S="${WORKDIR}/sau-v${PV}"

LICENSE="BSD"
SLOT="0"
KEYWORDS="amd64"
IUSE="selinux"

DEPEND="selinux? ( sec-policy/selinux-unconfined )
"
RDEPEND="${DEPEND}"
BDEPEND=""

python_compile_all() {
	#distutils-r1_python_compile()
	if use selinux; then
		cd "${S}/selinux"
		for i in ${POLICY_TYPES}; do
			make -f "${ROOT%/}/usr/share/selinux/${i}/include/Makefile"
			mv sau.pp sau-${i}.pp
		done
	fi
	default
}

python_install_all() {
	#distutils-r1_python_install()
	if use selinux; then
		for i in ${POLICY_TYPES}; do
			mkdir -p "${D}/usr/share/selinux/${i}"
			mv "${S}/selinux/sau-${i}.pp" "${D}/usr/share/selinux/${i}/sau.pp"
		done
	fi
	default
}


pkg_postinst() {
	if use selinux; then
		for i in ${POLICY_TYPES}; do
			cd "${ROOT%/}/usr/share/selinux/${i}"
			if [[ "${i}" != "strict" ]]; then
				semodule -s ${i} -i sau.pp
			fi
		done
		restorecon /usr/bin/sau
	fi
}

pkg_postrm() {
	if use selinux; then
		for i in ${POLICY_TYPES}; do
			if semodule -s "${i}" -l | grep sau >/dev/null 2>&1; then
				semodule -s ${i} -r sau
			fi
		done
	fi
}
